#include <stdint.h>
#include <string.h>

#include "STM32F100_types.h"

/* Defines */
#define PORTA 0
#define PORTB 1
#define PORTC 2
#define PORTD 3

#define GPIO_INPUT              0
#define GPIO_OUTPUT             1
#define GPIO_PULLUP             2
#define GPIO_PULLDOWN           3
#define GPIO_NO_PULLUP_PULLDOWN 4

/* Prototypes */
void wait_cycles(int N);
void setup_clock_HSE(uint8_t mult, uint8_t prediv);
void setup_clock_HSI(uint8_t mult, uint8_t prediv);
void initGPIO();
uint8_t getPinState(uint8_t port, uint8_t pin);
void setPinState(uint8_t port, uint8_t pin, uint8_t state);
void setPinDir(uint8_t port, uint8_t pin, uint8_t dir);
void setPinDirExt(uint8_t port, uint8_t pin, uint8_t dir, uint8_t pullup);
